Open a review
An agent opens a review for its run (through its daemon). CliqHub notifies the reviewers:
the reviewers groups (each a policy any or all and a list of channels or usernames),
or the realm’s members when none are given. mode is verdict (default, a decision),
chat (a conversation, starting with initial_message) or input_pause (a form to fill
in). The review expires after timeout_minutes (default 240). Answers 201.
Requires a daemon’s realm token (cliq_dt_…) for the realm given by realm_id.
curl --request POST \
--url https://{host}/v1/reviews/create \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"run_id": "0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f",
"daemon_id": "7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"payload": {
"title": "Approve the fix",
"message": "3 findings fixed; approve to merge."
},
"route_targets": [
"fix"
],
"reviewers": [
{
"policy": "any",
"channels": [
"sshah"
]
}
]
}
'import requests
url = "https://{host}/v1/reviews/create"
payload = {
"run_id": "0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f",
"daemon_id": "7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"payload": {
"title": "Approve the fix",
"message": "3 findings fixed; approve to merge."
},
"route_targets": ["fix"],
"reviewers": [
{
"policy": "any",
"channels": ["sshah"]
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
run_id: '0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f',
daemon_id: '7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d',
realm_id: '5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b',
payload: {title: 'Approve the fix', message: '3 findings fixed; approve to merge.'},
route_targets: ['fix'],
reviewers: [{policy: 'any', channels: ['sshah']}]
})
};
fetch('https://{host}/v1/reviews/create', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://{host}/v1/reviews/create",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'run_id' => '0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f',
'daemon_id' => '7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d',
'realm_id' => '5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b',
'payload' => [
'title' => 'Approve the fix',
'message' => '3 findings fixed; approve to merge.'
],
'route_targets' => [
'fix'
],
'reviewers' => [
[
'policy' => 'any',
'channels' => [
'sshah'
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://{host}/v1/reviews/create"
payload := strings.NewReader("{\n \"run_id\": \"0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f\",\n \"daemon_id\": \"7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"payload\": {\n \"title\": \"Approve the fix\",\n \"message\": \"3 findings fixed; approve to merge.\"\n },\n \"route_targets\": [\n \"fix\"\n ],\n \"reviewers\": [\n {\n \"policy\": \"any\",\n \"channels\": [\n \"sshah\"\n ]\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://{host}/v1/reviews/create")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"run_id\": \"0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f\",\n \"daemon_id\": \"7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"payload\": {\n \"title\": \"Approve the fix\",\n \"message\": \"3 findings fixed; approve to merge.\"\n },\n \"route_targets\": [\n \"fix\"\n ],\n \"reviewers\": [\n {\n \"policy\": \"any\",\n \"channels\": [\n \"sshah\"\n ]\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://{host}/v1/reviews/create")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"run_id\": \"0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f\",\n \"daemon_id\": \"7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"payload\": {\n \"title\": \"Approve the fix\",\n \"message\": \"3 findings fixed; approve to merge.\"\n },\n \"route_targets\": [\n \"fix\"\n ],\n \"reviewers\": [\n {\n \"policy\": \"any\",\n \"channels\": [\n \"sshah\"\n ]\n }\n ]\n}"
response = http.request(request)
puts response.read_bodyAuthorizations
User PAT (cliq_tok_…, including session-scoped) or realm token (cliq_dt_…).
Body
The run asking.
1The daemon running it.
1The run's realm.
1What the reviewer sees and answers (title, message, fields, artifacts).
Phases a reviewer may send the run back to with ROUTE:<phase>.
Minutes until the review expires (1 to 10080). Default 240.
1 <= x <= 10080Remind reviewers this often while pending. Default no reminders.
1 <= x <= 10080Reviewer groups: { policy: any | all, channels: [channel or username] }.
Show child attributes
Show child attributes
verdict (default), chat or input_pause.
input_pause, verdict, chat chat: the agent's first message.
10curl --request POST \
--url https://{host}/v1/reviews/create \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"run_id": "0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f",
"daemon_id": "7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"payload": {
"title": "Approve the fix",
"message": "3 findings fixed; approve to merge."
},
"route_targets": [
"fix"
],
"reviewers": [
{
"policy": "any",
"channels": [
"sshah"
]
}
]
}
'import requests
url = "https://{host}/v1/reviews/create"
payload = {
"run_id": "0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f",
"daemon_id": "7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d",
"realm_id": "5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b",
"payload": {
"title": "Approve the fix",
"message": "3 findings fixed; approve to merge."
},
"route_targets": ["fix"],
"reviewers": [
{
"policy": "any",
"channels": ["sshah"]
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
run_id: '0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f',
daemon_id: '7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d',
realm_id: '5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b',
payload: {title: 'Approve the fix', message: '3 findings fixed; approve to merge.'},
route_targets: ['fix'],
reviewers: [{policy: 'any', channels: ['sshah']}]
})
};
fetch('https://{host}/v1/reviews/create', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://{host}/v1/reviews/create",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'run_id' => '0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f',
'daemon_id' => '7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d',
'realm_id' => '5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b',
'payload' => [
'title' => 'Approve the fix',
'message' => '3 findings fixed; approve to merge.'
],
'route_targets' => [
'fix'
],
'reviewers' => [
[
'policy' => 'any',
'channels' => [
'sshah'
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://{host}/v1/reviews/create"
payload := strings.NewReader("{\n \"run_id\": \"0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f\",\n \"daemon_id\": \"7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"payload\": {\n \"title\": \"Approve the fix\",\n \"message\": \"3 findings fixed; approve to merge.\"\n },\n \"route_targets\": [\n \"fix\"\n ],\n \"reviewers\": [\n {\n \"policy\": \"any\",\n \"channels\": [\n \"sshah\"\n ]\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://{host}/v1/reviews/create")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"run_id\": \"0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f\",\n \"daemon_id\": \"7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"payload\": {\n \"title\": \"Approve the fix\",\n \"message\": \"3 findings fixed; approve to merge.\"\n },\n \"route_targets\": [\n \"fix\"\n ],\n \"reviewers\": [\n {\n \"policy\": \"any\",\n \"channels\": [\n \"sshah\"\n ]\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://{host}/v1/reviews/create")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"run_id\": \"0c8d7e6f-5a4b-4c3d-9e2f-1a0b9c8d7e6f\",\n \"daemon_id\": \"7d1c2b3a-4e5f-4a6b-8c7d-9e0f1a2b3c4d\",\n \"realm_id\": \"5b0c3a7e-2f4d-4b8e-9a51-7c1d2e3f4a5b\",\n \"payload\": {\n \"title\": \"Approve the fix\",\n \"message\": \"3 findings fixed; approve to merge.\"\n },\n \"route_targets\": [\n \"fix\"\n ],\n \"reviewers\": [\n {\n \"policy\": \"any\",\n \"channels\": [\n \"sshah\"\n ]\n }\n ]\n}"
response = http.request(request)
puts response.read_body